

unit Unit1; 

interface 

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, 
  StdCtrls, winsock; 

type 
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;


    Function  checkIP(HWSADataErr:Pchar;HIPAddress:Pchar):boolean;
    procedure Button1Click(Sender: TObject);
  private 
    { Dclarations prives } 
  public 
    { Dclarations publiques } 
  end; 

Type 
TaPInAddr = array [0..10] of PInAddr; 
PaPInAddr = ^TaPInAddr;

var
  Form1: TForm1; 

implementation 

{$R *.DFM} 

Function TForm1.checkIP(HWSADataErr:Pchar;HIPAddress:Pchar):boolean; 
var 
HHostEnt    : PHostEnt; 
HPaPinAddr  : PaPInAddr; 
HName      : array [0..255] of char; 
I          : Integer; 
HWSAData    : TWSADATA; 
SIPAddress  : ShortString; 
begin 

Result := false; 

if WSAStartup($0101, HWSAData) <> 0 then begin 
  case WSAGetLastError of 
  WSASYSNOTREADY    : HWSADataErr:=pchar('Indicates that the underlying network '+ 
                                    'subsystem is not ready for network communication.'); 
  WSAVERNOTSUPPORTED : HWSADataErr:=pchar('The version of Windows Sockets support '+ 
                                    'requested is not provided by this particular '+ 
                                    'Windows Sockets implementation.'); 
  WSAEINPROGRESS    : HWSADataErr:=pchar('A blocking Windows Sockets 1.1 operation is '+ 
                                    'in progress.'); 
  WSAEPROCLIM       : HWSADataErr:=pchar('Limit on the number of tasks supported by '+ 
                                    'the Windows Sockets implementation has been reached.'); 
  WSAEFAULT       : HWSADataErr:=pchar('The lpWSAData is not a valid pointer.'); 
  end; 
  Exit; 
end; 

if GetHostName(@HName, SizeOf(HName)) = 0 then begin 
  HHostEnt  :=GetHostByName(@HName); 
  if HHostEnt <> nil then begin 

  // IP Internet 
  HPaPinAddr := PaPInAddr(HHostEnt^.h_addr_list); 
  I := 0; 
  while HPaPinAddr^[I] <> nil do begin 
    SIPAddress:=StrPas(inet_ntoa(HPaPinAddr^[I]^)); 
    Inc(I); 
  end; 

  StrLcopy(HIPAddress,@SIPAddress[1],length(SIPAddress)); 
  Result:=true; 
  /////// 
{ 
  // IP PC Local  
  SIPAddress:=''; 
  for i:=0 to HHostEnt^.h_length - 1 do 
    SIPAddress:=SIPAddress + IntToStr(ord(HHostEnt^.h_addr_list^[i])) + '.'; 

  StrLcopy(HIPAddress,@SIPAddress[1],length(SIPAddress)-1); // on supprime le dernier '.' 
  Result:=true; 
  ////// 
} 
  end 
  else begin 
    case WSAGetLastError of 
    WSANOTINITIALISED : HWSADataErr:=pchar('A successful WSAStartup must occur before '+ 
                                      'using this function.'); 
    WSAENETDOWN      : HWSADataErr:=pchar('The network subsystem has failed.'); 
    WSAHOST_NOT_FOUND : HWSADataErr:=pchar('Authoritative Answer Host not found.'); 
    WSATRY_AGAIN      : HWSADataErr:=pchar('Non-Authoritative Host not found, or server failure.'); 
    WSANO_RECOVERY    : HWSADataErr:=pchar('Nonrecoverable error occurred.'); 
    WSANO_DATA       : HWSADataErr:=pchar('Valid name, no data record of requested type.'); 
    WSAEINPROGRESS    : HWSADataErr:=pchar('A blocking Windows Sockets 1.1 call is in '+ 
                                      'progress, or the service provider is still '+ 
                                      'processing a callback function.'); 
    WSAEFAULT       : HWSADataErr:=pchar('The name argument is not a valid part of '+ 
                                      'the user address space.'); 
    WSAEINTR          : HWSADataErr:=pchar('The (blocking) call was canceled through '+ 
                                      'WSACancelBlockingCall.'); 
    end; 
  end; 
end 
else begin 
  case WSAGetLastError of 
    WSAEFAULT          : HWSADataErr:=pchar('The name argument is not a valid part of the '+ 
                                      'user address space, or the buffer size specified '+ 
                                      'by namelen argument is too small to hold the '+ 
                                      'complete host name.'); 
    WSANOTINITIALISED  : HWSADataErr:=pchar('A successful WSAStartup must occur before '+ 
                                      'using this function.'); 
    WSAENETDOWN       : HWSADataErr:=pchar('The network subsystem has failed.'); 
    WSAEINPROGRESS    : HWSADataErr:=pchar('A blocking Windows Sockets 1.1 call is '+ 
                                      'in progress, or the service provider is '+ 
                                      'still processing a callback function.'); 
  end; 
end; 

WSACleanup; 
end; 




procedure TForm1.Button1Click(Sender: TObject); 
var 
MyError, 
MyIPAddress : array[0..255] of char; 
begin 
  if checkIP(@MyError,@MyIPAddress) then label1.caption:=string(MyIpAddress) 
  else label1.caption:=string(MyError); 
end; 






end.

